<!DOCTYPE html>
<html>
<head>
    <title></title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <#--baseJs-->
    <script src="${Uri.getUrl('/static/dist/lib.min.js')}" type="text/javascript"></script>
    <#--移动端ui-->
    <script src="${Uri.getUrl('/static/dist/mint-ui.min.js')}" type="text/javascript"></script>
    <link href="${Uri.getUrl('/static/dist/mint-ui.min.css')}" rel="stylesheet"/>
    <#--ajax接口-->
    <script src="${Uri.getUrl('/static/js/ajax.js')}" type="text/javascript"></script>
    <style>
        * {
            padding: 0px;
            margin: 0px;
        }

        html,body,#app{
            width: 100%;
            height: 100%;
        }

        .left-in-right-out-enter-active, .left-in-right-out-leave-active {
            transition: all 0.3s linear;
            position: absolute;
        }

        .left-in-right-out-enter {
            transform: translateX(-100%);
            opacity: 0;
        }

        .left-in-right-out-leave-to {
            transform: translateX(100%);
            opacity: 0;
        }

        .right-in-left-out-enter-active, .right-in-left-out-leave-active {
            transition: all .3s linear;
            position: absolute;
        }

        .right-in-left-out-enter {
            transform: translateX(100%);
        }

        .right-in-left-out-leave-to {
            transform: translateX(-100%);
        }

        .left-in-right-out-enter-active, .left-in-right-out-leave-active {
            transition: all 0.3s linear;
            position: absolute;
        }

        .left-in-right-out-enter {
            transform: translateX(-100%);
            opacity: 0;
        }

        .left-in-right-out-leave-to {
            transform: translateX(100%);
            opacity: 0;
        }

        .right-in-left-out-enter-active, .right-in-left-out-leave-active {
            transition: all .3s linear;
            position: absolute;
        }

        .right-in-left-out-enter {
            transform: translateX(100%);
        }

        .right-in-left-out-leave-to {
            transform: translateX(-100%);
        }
    </style>
</head>
<body>
<div id="app">
    <transition :name="transitionName">
        <router-view></router-view>
    </transition>
</div>

<template id="home">
    <div class="view">
        <mt-header title="Hello world">
            <router-link to="/" slot="left">
                <mt-button icon="back">返回</mt-button>
            </router-link>
            <mt-button icon="more" slot="right"></mt-button>
        </mt-header>
        <div class="content" style="text-align: center;padding-top: 200px">
            Hello world <router-link to="demo">demo</router-link>
        </div>
    </div>
</template>
<template id="demo">
    <div class="view">
        <mt-header title="表单输入">
            <mt-button icon="back" slot="left" @click="back">关闭</mt-button>
        </mt-header>
        <div class="content" style="text-align: center;">
            <mt-header title="Mint-ui自带控件"></mt-header>
            <mt-field label="普通文字" placeholder="请输入用户名" v-model="field1"></mt-field>
            <mt-field label="邮箱地址" placeholder="请输入邮箱" type="email" v-model="field2"></mt-field>
            <mt-field label="用户密码" placeholder="请输入密码" type="password" v-model="field3"></mt-field>
            <mt-field label="手机号码" placeholder="请输入手机号" type="tel" v-model="field4"></mt-field>
            <mt-field label="网站链接" placeholder="请输入网址" type="url" v-model="field5"></mt-field>
            <mt-field label="数字输入" placeholder="请输入数字" type="number" v-model="field6"></mt-field>
            <mt-field label="生日日期" placeholder="请输入生日" type="date" v-model="field7"></mt-field>
            <mt-field label="多行文字" placeholder="多行文字" type="textarea" rows="2" v-model="field8"></mt-field>

            <mt-header title="扩展控件"></mt-header>
            <wb-field-select label="文字选择" placeholder="请选择" :items="['男','女']" v-model="field10"></wb-field-select>
            <wb-field-dict label="字典选择" placeholder="请选择" :items="[{key:'1',value:'男'},{key:'2',value:'女'}]"
                           v-model="field11"></wb-field-dict>
            <wb-field-date label="日期选择" placeholder="请选择" v-model="field12"></wb-field-date>
            <wb-field-time label="时间选择" placeholder="请选择" v-model="field13"></wb-field-time>
            <wb-field-datetime label="日期时间" placeholder="请选择" v-model="field14"></wb-field-datetime>
            <wb-field-cphm label="车牌号码" placeholder="车牌号" v-model="field15"></wb-field-cphm>

            <wb-field-pictures label="选择照片" v-model="field16" @handle-file="handleFile"></wb-field-pictures>

            <div style="padding: 10px">
                <mt-button type="primary" size="large" @click="doSearch()">打印类容</mt-button>
            </div>
        </div>
    </div>
</template>

<script>
    var router = new VueRouter({
        routes: [
            {
                path: '/',
                name: 'home',
                component: Vue.extend({template: '#home'})
            },
            {
                path: '/demo',
                name: 'demo',
                component: Vue.extend({
                    template: '#demo',
                    mounted: function () {

                    },
                    data: function () {
                        return {
                            field1: '',
                            field2: '',
                            field3: '',
                            field4: '',
                            field5: '',
                            field6: '',
                            field7: '',
                            field8: '',
                            field9: '',
                            field10: '',
                            field11: '',
                            field12: '',
                            field13: '',
                            field14: '',
                            field15: '',
                            field16: '',
                        }
                    },
                    methods: {
                        doSearch: function () {
                            console.log(this.field10);
                            console.log(this.field11);
                            console.log(this.field12);
                            console.log(this.field13);
                            console.log(this.field14);
                            console.log(this.field15);
                            console.log(this.field16);
                        },
                        back: function () {
                            if (window.android) {
                                android.finish()
                            } else {
                                location.href = "${Uri.getUrl('/app/index.htm')}"
                            }
                        },
                        handleFile: function (file, call) {
                            //do upload
                            console.log("正在上传文件" + file.name);
                            if (true) {
                                call.finish();
                            } else {
                                call.cancel();
                            }
                        }
                    }
                })
            }
        ]
    });
    var app = new Vue({
        el: '#app',
        data: {
            transitionName: ''
        },
        router: router,
        watch: {
            '$route': function (to, from) {
                this.transitionName = to.meta.index < from.meta.index ? 'left-in-right-out' : 'right-in-left-out'
            }
        }
    })
</script>
</html>
